Index: /orxonox/branches/parenting/src/camera.cc
===================================================================
--- /orxonox/branches/parenting/src/camera.cc	(revision 3341)
+++ /orxonox/branches/parenting/src/camera.cc	(revision 3342)
@@ -42,7 +42,4 @@
   this->t = 0.0;
 
-  this->actualPlace.r.x = 0.0;
-  this->actualPlace.r.y = 10.0;
-  this->actualPlace.r.z = -5.0;
 
   this->setDrawable (false);
@@ -69,5 +66,5 @@
   //printf("time is: t=%f\n", t );
   updateDesiredPlace();
-  jump(NULL);
+  //jump(NULL);
 }
 
@@ -171,10 +168,6 @@
       /* the camera is handled like an entity and rolls on the track */
     case NORMAL:
-      Location lookat;  
       if( bound != NULL && world != NULL )
 	{
-	  //bound->getLookat (&lookat);
-	  //bound->getAbsCoor ()
-	  //world->calcCameraPos (&lookat, &desiredPlace);
 	  //FIXME: camera should be made via relative coordinates
 	  Vector* cameraOffset = new Vector (-10, 5, 0);
@@ -254,23 +247,5 @@
 }
 
-/**
-  \brief set the camera position
-  \param plc: The Placement to set the camera to 
-	
-	This will set the actual and desired placement of the camera to plc
-*/
-void Camera::jump (Placement* plc = NULL)
-{
-  if( plc == NULL)
-    {
-      actualPlace = desiredPlace;
-      //printf("Camera|jump: camer@ %f, %f, %f\n\n", actual_place.r.x, actual_place.r.y, actual_place.r.z);
-    }
-  else
-    {
-      desiredPlace = *plc;
-      actualPlace = *plc;
-    }
-}
+
 
 /**
Index: /orxonox/branches/parenting/src/camera.h
===================================================================
--- /orxonox/branches/parenting/src/camera.h	(revision 3341)
+++ /orxonox/branches/parenting/src/camera.h	(revision 3342)
@@ -27,6 +27,4 @@
  private:
   WorldEntity* bound;		//!< the WorldEntity the Camera is bound to
-  Placement actualPlace;	        //!< the Camera's current position
-  Placement desiredPlace;        //!< where the Camera should be according to calculations
   World* world;
   
@@ -38,5 +36,4 @@
   
   /* elliptical camera mode variables */
-  Placement plLastBPlace;
   float cameraOffset;
   float cameraOffsetZ;
@@ -64,5 +61,4 @@
   void apply ();
   void bind (WorldEntity* entity);
-  void jump (Placement* plc);
   void destroy();
 
Index: /orxonox/branches/parenting/src/stdincl.h
===================================================================
--- /orxonox/branches/parenting/src/stdincl.h	(revision 3341)
+++ /orxonox/branches/parenting/src/stdincl.h	(revision 3342)
@@ -35,5 +35,5 @@
 #include "matrix.h"
 #include "curve.h"
-#include "coordinates.h"
+//#include "coordinates.h"
 #include "list.h"
 #include "list_template.h"
Index: /orxonox/branches/parenting/src/track.cc
===================================================================
--- /orxonox/branches/parenting/src/track.cc	(revision 3341)
+++ /orxonox/branches/parenting/src/track.cc	(revision 3342)
@@ -61,71 +61,5 @@
 
 
-/**
-   \brief calculate a camera Placement from a "look at"-Location
-   \param lookat: the Location the camera should be centered on
-   \param camplc: pointer to a buffer where the new camera Placement should be put into
-   
-   Theoretically you can place the camera wherever you want, but for the sake of 
-   common sense I suggest that you at least try to keep the thing that should be looked
-   at inside camera boundaries.
-*/
-void Track::mapCamera (Location* lookat, Placement* camplc)
-{
-  Line trace(*offset, *end - *offset);
-  float l = trace.len ();
-  
-  //	camplc->r = *offset + Vector(0,0,0.5);
-  //	camplc->w = Quaternion (trace.a, Vector(0,0,1));
-  float r = (lookat->dist)*PI / l;
-  camplc->r = trace.r + (trace.a * ((lookat->dist-10.0) / l)) + Vector(0,0,5.0);
-  
-  Vector w(0.0,0.0,0.0);
-  w=Vector(0,0,0) - ((trace.r + (trace.a * ((lookat->dist) / l)) - camplc->r));
-  //Vector up(0.0,sin(r),cos(r)); // corrupt...
-  Vector up(0.0, 0.0, 1.0);
 
-  camplc->w = Quaternion(w, up);
-
-  //printf("\n------\nup vector: [%f, %f, %f]\n", up.x, up.y, up.z);
-  //printf("direction: [%f, %f, %f]\n", w.x, w.y, w.z);
-  //printf("quaternion: w[ %f ], v[ %f, %f, %f ]\n", camplc->w.w, camplc->w.v.x, camplc->w.v.y, camplc->w.v.z);
-}
-
-/**
-   \brief calculate a Placement from a given Location
-   \param loc: the Location the entity is in
-   \param plc: a pointer to a buffer where the corresponding Placement should be put
-   into
-   \return: true if track changes - false if track stays
-   
-   There are no limitations to how you transform a Location into a Placement, but for 
-   the sake of placement compatibility between track parts you should make sure that 
-   the resulting Placement at dist == 0 is equal to the offset Vector and the Placement
-   at dist == len() is equal to the end Vector. Elseway there will be ugly artifacts 
-   when transfering between track parts.
-*/
-bool Track::mapCoords (Location* loc, Placement* plc)
-{
-  Line trace(*offset, *end - *offset);
-  float l = trace.len ();
-  
-  /* change to the next track? */
-  if( loc->dist > l)
-    {
-      loc->dist -= l;
-      loc->part = nextID;
-      //FIXME: loc->track = this;
-      return true;
-    }
-  
-  /* this quaternion represents the rotation from start-vector (0,0,1) to the direction of
-   * the track */
-  Quaternion dir(trace.a, Vector(0,0,1)); 
-  
-  plc->r = trace.r + (trace.a * ((loc->dist) / l)) + /*dir.apply*/(loc->pos);
-  plc->w = dir * loc->rot;
-  
-  return false;
-}
 
 
Index: /orxonox/branches/parenting/src/track.h
===================================================================
--- /orxonox/branches/parenting/src/track.h	(revision 3341)
+++ /orxonox/branches/parenting/src/track.h	(revision 3342)
@@ -35,6 +35,4 @@
   virtual void postLeave (WorldEntity* entity);
   virtual void tick (float deltaT);
-  virtual void mapCamera (Location* lookat, Placement* camplc);
-  virtual bool mapCoords (Location* loc, Placement* plc);	// this should return true if the entity left track boundaries
 };
 
Index: /orxonox/branches/parenting/src/world.cc
===================================================================
--- /orxonox/branches/parenting/src/world.cc	(revision 3341)
+++ /orxonox/branches/parenting/src/world.cc	(revision 3342)
@@ -751,15 +751,4 @@
 
 
-
-/**
-   \brief calls the correct mapping function to convert a given "look at"-Location to a 
-   Camera Placement
-*/
-void World::calcCameraPos (Location* loc, Placement* plc)
-{
-  track[loc->part].mapCamera (loc, plc);
-}
-
-
 void World::setTrackLen(Uint32 len)
 {
Index: /orxonox/branches/parenting/src/world.h
===================================================================
--- /orxonox/branches/parenting/src/world.h	(revision 3341)
+++ /orxonox/branches/parenting/src/world.h	(revision 3342)
@@ -24,9 +24,4 @@
   World (int worldID);
   virtual ~World ();
-
-  template<typename T> 
-    T* spawn (Location* loc, WorldEntity* owner);	// template to be able to spawn any derivation of WorldEntity
-  template<typename T> 
-    T* spawn (Placement* plc, WorldEntity* owner);
   
   virtual ErrorMessage init ();
@@ -45,5 +40,5 @@
   void draw ();
   void update ();	// maps Locations to Placements
-  void calcCameraPos (Location* loc, Placement* plc);
+  //void calcCameraPos (Location* loc, Placement* plc);
 	
   void unload ();
Index: /orxonox/branches/parenting/src/world_entity.cc
===================================================================
--- /orxonox/branches/parenting/src/world_entity.cc	(revision 3341)
+++ /orxonox/branches/parenting/src/world_entity.cc	(revision 3342)
@@ -161,22 +161,4 @@
 
 /**
-   \brief basic initialisation for bound Entities
-*/
-void WorldEntity::init( Location* spawnloc, WorldEntity* spawnowner)
-{
-  //  loc = *spawnloc;
-  //owner = spawnowner;
-}
-
-/**
-   \brief basic initialisation for free Entities
-*/
-void WorldEntity::init( Placement* spawnplc, WorldEntity* spawnowner)
-{
-  //place = *spawnplc;
-  //owner = spawnowner;
-}
-
-/**
    \brief this is called immediately after the Entity has been constructed and initialized
    
Index: /orxonox/branches/parenting/src/world_entity.h
===================================================================
--- /orxonox/branches/parenting/src/world_entity.h	(revision 3341)
+++ /orxonox/branches/parenting/src/world_entity.h	(revision 3342)
@@ -24,7 +24,4 @@
   Object* model;
   
-  //PNode* pNode;
-  //PN Location* getLocation ();
-  //PN Placement* getPlacement ();
   void setCollision (CollisionCluster* newhull);
   
@@ -44,5 +41,4 @@
   virtual void draw ();
   void setDrawable (bool bDraw);
-  //PN virtual void getLookat (Location* locbuf);
   
   virtual void leftWorld ();
@@ -53,11 +49,5 @@
   bool bDraw;
 
-  //PN WorldEntity* owner;
   CollisionCluster* collisioncluster;
-  //PN Placement place;
-  //PN Location loc;
-  
-  void init( Location* spawnloc, WorldEntity* spawnowner);
-  void init( Placement* spawnplc, WorldEntity* spawnowner);
 };
 